package com.izouma.zhirongip.web.demand;

import com.izouma.zhirongip.domain.Setting;
import com.izouma.zhirongip.dto.PatentDemandExcelDto;
import com.izouma.zhirongip.dto.PatentExcelDto;
import com.izouma.zhirongip.repo.SettingRepo;
import com.izouma.zhirongip.service.SettingService;
import com.izouma.zhirongip.utils.SecurityUtils;
import com.izouma.zhirongip.web.BaseController;
import com.izouma.zhirongip.domain.demand.PatentDemand;
import com.izouma.zhirongip.service.demand.PatentDemandService;
import com.izouma.zhirongip.dto.PageQuery;
import com.izouma.zhirongip.exception.BusinessException;
import com.izouma.zhirongip.repo.demand.PatentDemandRepo;
import com.izouma.zhirongip.utils.ObjUtils;
import com.izouma.zhirongip.utils.excel.ExcelUtils;

import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.data.domain.Page;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.InputStream;
import java.util.List;
import java.util.stream.Collectors;

@RestController
@RequestMapping("/patentDemand")
@AllArgsConstructor
@Slf4j
public class PatentDemandController extends BaseController {
    private final PatentDemandService patentDemandService;
    private final PatentDemandRepo    patentDemandRepo;
    private final SettingRepo         settingRepo;
    private final SettingService      settingService;

    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public PatentDemand save(@RequestBody PatentDemand record) {
        if (record.getId() != null) {
            PatentDemand orig = patentDemandRepo.findById(record.getId()).orElseThrow(new BusinessException("无记录"));
            ObjUtils.merge(orig, record);
            return patentDemandRepo.save(orig);
        }
        record.setUserId(SecurityUtils.getAuthenticatedUser().getId());
        return patentDemandRepo.save(record);
    }


    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/all")
    public Page<PatentDemand> all(@RequestBody PageQuery pageQuery) {
        Page<PatentDemand> all = patentDemandService.all(pageQuery);
        all.getContent().forEach(d -> {
            d.setUserId(null);
            d.setPatentTypeId(null);
            d.setPatentStatusId(null);
            d.setModeId(null);
        });
        return all;
    }

    @GetMapping("/get/{id}")
    public PatentDemand get(@PathVariable Long id) {
        PatentDemand record = patentDemandRepo.findById(id).orElseThrow(new BusinessException("无记录"));
        settingRepo.findById(record.getIndustryClass())
                   .ifPresent(setting -> record.setIndustryName(setting.getName()));
        if (record.getModeId() != null) {
            settingRepo.findById(record.getModeId())
                       .ifPresent(setting -> record.setMode(setting.getName()));
        }
        if (record.getPatentStatusId() != null) {
            settingRepo.findById(record.getPatentStatusId())
                       .ifPresent(setting -> record.setPatentStatus(setting.getName()));
        }
        if (record.getPatentTypeId() != null) {
            settingRepo.findById(record.getPatentTypeId())
                       .ifPresent(setting -> record.setPatentType(setting.getName()));
        }
        return record;
    }

    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        patentDemandRepo.softDelete(id);
    }

    @GetMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<PatentDemandExcelDto> data = all(pageQuery)
                .getContent().stream()
                .map(PatentDemandExcelDto::from)
                .collect(Collectors.toList());
        List<Setting> settings = settingService.getTree(settingRepo.findAllByFlag(1));
        data.forEach(d -> {
            d.setIndustryName(settings.stream().filter(s -> s.getId().equals(d.getIndustryClass())).findFirst()
                                      .map(Setting::getName).orElse(null));
        });
        ExcelUtils.export(response, data);
    }

    @PreAuthorize("hasRole('ADMIN')")
    @ApiOperation("审核")
    @PostMapping("/audit")
    public void audit(@RequestParam Long id, @RequestParam boolean pass, String remark) {
        patentDemandService.audit(id, pass, remark);
    }

    @PostMapping("/upload")
    public void uploadFile(@RequestParam("file") MultipartFile file) {
        InputStream is;
        try {
            is = file.getInputStream();
            patentDemandService.upload1(is);
        } catch (IOException e) {
            log.error("上传失败", e);
            throw new BusinessException("上传失败", e.getMessage());
        }
    }
}

